# Written by Bram Cohen
# see LICENSE.txt for license information
# Updated and modified for ABC_OKC : Old King Cole

from time import clock


class Measure:
    def __init__(self, maxrateperiod):
        self.maxrateperiod = maxrateperiod
        self.start = self.last = clock()
        self.rate = 0.0
        self.total = 0l

    def update_rate(self, amount):
        now = clock()
        window = min(self.maxrateperiod, now - self.start)
        self.rate = (self.rate * max(self.last - now + window, 0) + amount) / window
        self.total += amount
        self.last = now
        return self.rate

    def get_rate(self):
        now = clock()
        window = min(self.maxrateperiod, now - self.start)
        return self.rate * max(self.last - now + window, 0) / window

    def get_total(self):
        return self.total
